Loading...
Searching...
No Matches
DcmDate Class Reference

a class representing the DICOM value representation 'Date' (DA) More...

Inheritance diagram for DcmDate:

## Public Member Functions

| DcmDate (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmDate (const DcmDate &old)
| copy constructor
virtual | ~DcmDate ()
| destructor
DcmDate & | operator= (const DcmDate &obj)
| assignment operator
virtual DcmObject * | clone () const
| clone method
virtual OFCondition | copyFrom (const DcmObject &rhs)
| Virtual object copying.
virtual DcmEVR | ident () const
| get element type identifier
virtual OFCondition | checkValue (const OFString &vm="1-n", const OFBool oldFormat=OFFalse)
| check whether stored value conforms to the VR and to the specified VM
virtual OFCondition | getOFString (OFString &stringVal, const unsigned long pos, OFBool normalize=OFTrue)
| get a copy of a particular string component
OFCondition | setCurrentDate ()
| set the element value to the current system date.
OFCondition | setOFDate (const OFDate &dateValue)
| set the element value to the given date
OFCondition | getOFDate (OFDate &dateValue, const unsigned long pos=0, const OFBool supportOldFormat=OFTrue)
| get the current element value in OFDate format.
OFCondition | getISOFormattedDate (OFString &formattedDate, const unsigned long pos=0, const OFBool supportOldFormat=OFTrue)
| get the current element value in ISO date format.
virtual OFBool | matches (const OFString &key, const OFString &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching on a single pair of string values.
virtual OFBool | combinationMatches (const DcmElement &keySecond, const DcmElement &candidateFirst, const DcmElement &candidateSecond) const
| perform combined attribute matching.
virtual OFBool | matches (const DcmElement &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching.
Public Member Functions inherited from DcmByteString
| DcmByteString (const DcmTag &tag)
| constructor.
| DcmByteString (const DcmByteString &old)
| copy constructor
virtual | ~DcmByteString ()
| destructor
DcmByteString & | operator= (const DcmByteString &obj)
| assignment operator
virtual int | compare (const DcmElement &rhs) const
| comparison operator that compares the normalized value of this object with a given object of the same type.
virtual OFCondition | clear ()
| clear the currently stored value
virtual unsigned long | getVM ()
| get value multiplicity
virtual unsigned long | getNumberOfValues ()
| get number of values stored in this element.
Uint32 | getRealLength ()
| get length of the stored value.
virtual Uint32 | getLength (const E_TransferSyntax xfer=EXS_LittleEndianImplicit, const E_EncodingType enctype=EET_UndefinedLength)
| get DICOM length of the stored value.
virtual void | print (STD_NAMESPACE ostream &out, const size_t flags=0, const int level=0, const char *pixelFileName=NULL, size_t *pixelCounter=NULL)
| print element to a stream.
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| write data element to a stream
virtual OFCondition | writeSignatureFormat (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| write data element to a stream as required for the creation of digital signatures
virtual OFCondition | getOFStringArray (OFString &stringVal, OFBool normalize=OFTrue)
| get entire element value as a character string.
virtual OFCondition | getString (char *&stringVal)
| get a pointer to the current string value.
virtual OFCondition | getString (char *&stringVal, Uint32 &stringLen)
| get a pointer to the current string value.
virtual OFCondition | putString (const char *stringVal)
| set element value from the given character string.
virtual OFCondition | putOFStringAtPos (const OFString &stringVal, const unsigned long pos=0)
| set element value at specific VM position in the given character string.
virtual OFCondition | putString (const char *stringVal, const Uint32 stringLen)
| set element value from the given character string.
virtual OFCondition | verify (const OFBool autocorrect=OFFalse)
| check the currently stored string value.
virtual OFBool | containsExtendedCharacters (const OFBool checkAllStrings=OFFalse)
| check if this element contains non-ASCII characters.
virtual OFBool | isAffectedBySpecificCharacterSet () const
| check if this element is affected by SpecificCharacterSet
virtual OFBool | isEmpty (const OFBool normalize=OFTrue)
| check if this object is empty
virtual OFCondition | writeJson (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write object in JSON format
Public Member Functions inherited from DcmElement
| DcmElement (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmElement (const DcmElement &old)
| copy constructor
virtual | ~DcmElement ()
| destructor
DcmElement & | operator= (const DcmElement &obj)
| assignment operator
virtual Uint32 | calcElementLength (const E_TransferSyntax xfer, const E_EncodingType enctype)
| calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences.
virtual OFBool | isLeaf () const
| check if this element is a leaf node in a dataset tree.
virtual OFBool | isElement () const
| check if this element can be safely casted to DcmElement
OFBool | valueLoaded () const
| check if value of this element is loaded into main memory
virtual void | transferInit ()
| initialize the transfer state of this object.
virtual OFBool | canWriteXfer (const E_TransferSyntax newXfer, const E_TransferSyntax oldXfer)
| check if this DICOM object can be encoded in the given transfer syntax.
virtual OFCondition | read (DcmInputStream &inStream, const E_TransferSyntax ixfer, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength)
| This function reads the data value of an attribute which is captured in the input stream and captures this information in this.
virtual OFCondition | writeXML (STD_NAMESPACE ostream &out, const size_t flags=0)
| write object in XML format
virtual OFCondition | loadAllDataIntoMemory ()
| this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory.
virtual OFCondition | getUint8 (Uint8 &val, const unsigned long pos=0)
| retrieve a single value of type Uint8.
virtual OFCondition | getSint16 (Sint16 &val, const unsigned long pos=0)
| retrieve a single value of type Sint16.
virtual OFCondition | getUint16 (Uint16 &val, const unsigned long pos=0)
| retrieve a single value of type Uint16.
virtual OFCondition | getSint32 (Sint32 &val, const unsigned long pos=0)
| retrieve a single value of type Sint32.
virtual OFCondition | getUint32 (Uint32 &val, const unsigned long pos=0)
| retrieve a single value of type Uint32.
virtual OFCondition | getFloat32 (Float32 &val, const unsigned long pos=0)
| retrieve a single value of type Float32.
virtual OFCondition | getSint64 (Sint64 &val, const unsigned long pos=0)
| retrieve a single value of type Sint64.
virtual OFCondition | getUint64 (Uint64 &val, const unsigned long pos=0)
| retrieve a single value of type Uint64.
virtual OFCondition | getFloat64 (Float64 &val, const unsigned long pos=0)
| retrieve a single value of type Float64.
virtual OFCondition | getTagVal (DcmTagKey &val, const unsigned long pos=0)
| retrieve a single value of type DcmTagKey.
virtual OFCondition | getUint8Array (Uint8 *&val)
| get a pointer to the element value of the current element as type string.
virtual OFCondition | getSint16Array (Sint16 *&val)
| get a pointer to the element value of the current element as type Sint16.
virtual OFCondition | getUint16Array (Uint16 *&val)
| get a pointer to the element value of the current element as type Uint16.
virtual OFCondition | getSint32Array (Sint32 *&val)
| get a pointer to the element value of the current element as type Sint32.
virtual OFCondition | getUint32Array (Uint32 *&val)
| get a pointer to the element value of the current element as type Uint32.
virtual OFCondition | getFloat32Array (Float32 *&val)
| get a pointer to the element value of the current element as type Float32.
virtual OFCondition | getSint64Array (Sint64 *&val)
| get a pointer to the element value of the current element as type Sint64.
virtual OFCondition | getUint64Array (Uint64 *&val)
| get a pointer to the element value of the current element as type Uint64.
virtual OFCondition | getFloat64Array (Float64 *&val)
| get a pointer to the element value of the current element as type Float64.
OFCondition | detachValueField (OFBool copy=OFFalse)
| detach the value field from the DICOM element (i.e., this object).
virtual OFCondition | putOFStringArray (const OFString &val)
| replace the element value by a copy of the given string (which is possibly multi-valued).
virtual OFCondition | putSint16 (const Sint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint16 value.
virtual OFCondition | putUint16 (const Uint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint16 value.
virtual OFCondition | putSint32 (const Sint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint32 value.
virtual OFCondition | putUint32 (const Uint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint32 value.
virtual OFCondition | putFloat32 (const Float32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float32 value.
virtual OFCondition | putSint64 (const Sint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint64 value.
virtual OFCondition | putUint64 (const Uint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint64 value.
virtual OFCondition | putFloat64 (const Float64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float64 value.
virtual OFCondition | putTagVal (const DcmTagKey &attrTag, const unsigned long pos=0)
| insert into the element value a copy of the given DcmTagKey value.
virtual OFCondition | putUint8Array (const Uint8 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint8 array (which is possibly multi-valued).
virtual OFCondition | putSint16Array (const Sint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint16 array (which is possibly multi-valued).
virtual OFCondition | putUint16Array (const Uint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint16 array (which is possibly multi-valued).
virtual OFCondition | putSint32Array (const Sint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint32 array (which is possibly multi-valued).
virtual OFCondition | putUint32Array (const Uint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint32 array (which is possibly multi-valued).
virtual OFCondition | putFloat32Array (const Float32 *vals, const unsigned long num)
| replace the element value by a copy of the given Float32 array (which is possibly multi-valued).
virtual OFCondition | putSint64Array (const Sint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint64 array (which is possibly multi-valued).
virtual OFCondition | putUint64Array (const Uint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint64 array (which is possibly multi-valued).
virtual OFCondition | putFloat64Array (const Float64 *vals, const unsigned long num)
| replace the element value by a copy of the given Float64 array (which is possibly multi-valued).
virtual OFCondition | getPartialValue (void *targetBuffer, const Uint32 offset, Uint32 numBytes, DcmFileCache *cache=NULL, E_ByteOrder byteOrder=gLocalByteOrder)
| Copy numBytes bytes of data from the attribute value in byteOrder byte order to targetBuffer, starting at byte offset offset of the attribute value.
virtual OFCondition | createUint8Array (const Uint32 numBytes, Uint8 *&bytes)
| create an empty Uint8 array of given number of bytes and set it.
virtual OFCondition | createUint16Array (const Uint32 numWords, Uint16 *&words)
| create an empty Uint16 array of given number of words and set it.
virtual OFCondition | createValueFromTempFile (DcmInputStreamFactory *factory, const Uint32 length, const E_ByteOrder byteOrder)
| replace the attribute value with the content of the given temporary file.
virtual void | compact ()
| remove the attribute value from memory if the attribute value can be loaded from file when needed again.
virtual OFCondition | getUncompressedFrameSize (DcmItem *dataset, Uint32 &frameSize, OFBool pixelDataIsUncompressed) const
| compute uncompressed frame size of a single frame of this image.
virtual OFCondition | getUncompressedFrame (DcmItem *dataset, Uint32 frameNo, Uint32 &startFragment, void *buffer, Uint32 bufSize, OFString &decompressedColorModel, DcmFileCache *cache=NULL)
| access single frame without decompressing or loading a complete multi-frame object.
virtual OFCondition | getDecompressedColorModel (DcmItem *dataset, OFString &decompressedColorModel)
| determine color model of the decompressed image
virtual OFBool | isUniversalMatch (const OFBool normalize=OFTrue, const OFBool enableWildCardMatching=OFTrue)
| Determine if this element is universal matching.
const DcmInputStreamFactory * | getInputStream () const
| returns a pointer to the input stream, if available, NULL otherwise.
virtual Uint16 | decodedBitsAllocated (Uint16 bitsAllocated, Uint16 bitsStored) const
| determines the effective value of BitsAllocated that a dataset will have after decompression of an image with the given values for bitsAllocated and bitsStored.
Public Member Functions inherited from DcmObject
| DcmObject (const DcmTag &tag, const Uint32 len=0)
| constructor.
| DcmObject (const DcmObject &obj)
| copy constructor
virtual | ~DcmObject ()
| destructor
DcmObject & | operator= (const DcmObject &obj)
| copy assignment operator
DcmEVR | getVR () const
| return the value representation assigned to this object.
OFBool | isaString () const
| check if this element is a string type, based on the VR.
virtual OFBool | isNested () const
| check if this element is nested in a sequence of items, i.e. not a top-level or stand-alone element
E_TransferState | transferState () const
| return the current transfer (read/write) state of this object.
virtual void | transferEnd (void)
| finalize the transfer state of this object.
DcmItem * | getRootItem ()
| get root dataset/item (top-level) that contains this object.
virtual DcmItem * | getParentItem ()
| get parent item of this object.
DcmObject * | getParent ()
| get parent of this object.
const DcmObject * | getParent () const
| get parent of this object.
void | setParent (DcmObject *parent)
| set parent of this object.
Uint16 | getGTag () const
| return the group number of the attribute tag for this object
Uint16 | getETag () const
| return the element number of the attribute tag for this object
const DcmTag & | getTag () const
| return const reference to the attribute tag for this object
void | setGTag (Uint16 gtag)
| assign group tag (but not element tag) of the attribute tag for this object.
virtual OFCondition | setVR (DcmEVR vr)
| assign a new Value Representation (VR) to this object.
virtual OFBool | isSignable () const
| returns true if the current object may be included in a digital signature
virtual OFBool | containsUnknownVR () const
| returns true if the object contains an element with Unknown VR at any nesting level
virtual OFCondition | convertCharacterSet (DcmSpecificCharacterSet &converter)
| convert this object from the currently selected source character set to the currently selected destination character set (if affected by SpecificCharacterSet)
virtual DcmObject * | nextInContainer (const DcmObject *obj)
| this method is only used in container classes derived from this class, that is, DcmItem and DcmSequenceOfItems.
virtual OFCondition | nextObject (DcmStack &stack, const OFBool intoSub)
| this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems).
virtual OFCondition | search (const DcmTagKey &xtag, DcmStack &resultStack, E_SearchMode mode=ESM_fromHere, OFBool searchIntoSub=OFTrue)
| a complex, stack-based, hierarchical search method.
Uint32 | getLengthField () const
| return the current value of the Length field (which is different from the functionality of the public getLength() method).

## Static Public Member Functions

static OFCondition | getCurrentDate (OFString &dicomDate)
| get the current system date.
static OFCondition | getDicomDateFromOFDate (const OFDate &dateValue, OFString &dicomDate)
| get the specified OFDate value in DICOM format.
static OFCondition | getOFDateFromString (const OFString &dicomDate, OFDate &dateValue)
| get the specified DICOM date value in OFDate format.
static OFCondition | getOFDateFromString (const OFString &dicomDate, OFDate &dateValue, const OFBool supportOldFormat)
| get the specified DICOM date value in OFDate format.
static OFCondition | getOFDateFromString (const char *dicomDate, const size_t dicomDateSize, OFDate &dateValue)
| get the specified DICOM date value in OFDate format.
static OFCondition | getOFDateFromString (const char *dicomDate, const size_t dicomDateSize, OFDate &dateValue, const OFBool supportOldFormat)
| get the specified DICOM date value in OFDate format.
static OFCondition | getISOFormattedDateFromString (const OFString &dicomDate, OFString &formattedDate, const OFBool supportOldFormat=OFTrue)
| get the specified DICOM date value in ISO format.
static OFBool | check (const char *dicomDate, const size_t dicomDateSize)
| check whether the given string conforms to a single value of VR "DA" (Date).
static OFBool | check (const char *dicomDate, const size_t dicomDateSize, const OFBool supportOldFormat)
| check whether the given string conforms to a single value of VR "DA" (Date).
static OFCondition | checkStringValue (const OFString &value, const OFString &vm="1-n", const OFBool oldFormat=OFFalse)
| check whether given string value conforms to the VR "DA" (Date) and to the specified VM.
Static Public Member Functions inherited from DcmElement
static int | scanValue (const OFString &value, const OFString &vr, const size_t pos=0, const size_t num=OFString_npos)
| scan string value for conformance with given value representation (VR)
static int | scanValue (const OFString &vr, const char *const value, const size_t size)
| scan string value for conformance with given value representation (VR)
static unsigned long | determineVM (const char *str, const size_t len)
| determine the number of values stored in a string, i.e. the value multiplicity (VM)
static size_t | getValueFromString (const char *str, const size_t pos, const size_t len, OFString &val)
| get the first value stored in the given string.
static OFCondition | checkVM (const unsigned long vmNum, const OFString &vmStr)
| check for correct value multiplicity (VM)

## Additional Inherited Members

Protected Types inherited from DcmByteString
enum | E_StringMode { DCM_MachineString , DCM_DicomString , DCM_UnknownString }
| internal type used to specify the current string representation More...
Protected Member Functions inherited from DcmByteString
| DcmByteString (const DcmTag &tag, const Uint32 len)
| constructor.
virtual Uint8 * | newValueField ()
| create a new value field (string buffer) of the previously defined size (member variable 'Length').
virtual void | postLoadValue ()
| method is called after the element value has been loaded.
E_StringMode | getStringMode () const
| get current representation of the string value
virtual OFCondition | makeMachineByteString (const Uint32 length=0)
| convert currently stored string value to internal representation.
OFCondition | makeDicomByteString ()
| convert currently stored string value to DICOM representation.
OFCondition | getStringValue (OFString &stringVal)
| get a copy of the current string value.
Uint32 | getMaxLength () const
| get the maximum number of characters for each string component
char | getPaddingChar () const
| get the end-of-string padding character
void | setPaddingChar (char c)
| set the end-of-string padding character
void | setMaxLength (Uint32 val)
| set the maximum number of characters for each string component
void | setNonSignificantChars (const OFString &characters)
| set non-significant characters used to determine whether the value is empty
Protected Member Functions inherited from DcmElement
void * | getValue (const E_ByteOrder newByteOrder=gLocalByteOrder)
| This function returns this element's value.
OFCondition | changeValue (const void *value, const Uint32 position, const Uint32 num)
| insert into the element value a copy of the given raw value.
OFCondition | putValue (const void *value, const Uint32 length)
| replace the element value by a copy of the given raw data block
OFCondition | createEmptyValue (const Uint32 length)
| create a new, empty value field of given size.
OFCondition | loadValue (DcmInputStream *inStream=NULL)
| This function reads the data value of an attribute and stores the information which was read in this.
void | swapValueField (size_t valueWidth)
| swaps the content of the value field (if loaded) from big-endian to little-endian or back
virtual void | writeXMLStartTag (STD_NAMESPACE ostream &out, const size_t flags, const char *attrText=NULL)
| write element start tag in XML format
virtual void | writeXMLEndTag (STD_NAMESPACE ostream &out, const size_t flags)
| write element end tag in XML format
virtual void | writeJsonOpener (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element start tag in JSON format
virtual void | writeJsonCloser (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element end tag in JSON format
E_ByteOrder | getByteOrder () const
| return the current byte order of the value field
void | setByteOrder (E_ByteOrder val)
| set the current byte order of the value field
Protected Member Functions inherited from DcmObject
void | printNestingLevel (STD_NAMESPACE ostream &out, const size_t flags, const int level)
| print line indentation, e.g. a couple of spaces for each nesting level.
void | printInfoLineStart (STD_NAMESPACE ostream &out, const size_t flags, const int level, DcmTag *tag=NULL)
| print beginning of the info line.
void | printInfoLineEnd (STD_NAMESPACE ostream &out, const size_t flags, const unsigned long printedLength=0xffffffff, DcmTag *tag=NULL)
| print end of the info line.
virtual void | printInfoLine (STD_NAMESPACE ostream &out, const size_t flags, const int level=0, const char *info=NULL, DcmTag *tag=NULL, const OFBool isInfo=OFTrue)
| print given text with element information.
virtual OFCondition | writeTagAndLength (DcmOutputStream &outStream, const E_TransferSyntax oxfer, Uint32 &writtenBytes) const
| write tag, VR and length field to the given output stream
virtual Uint32 | getTagAndLengthSize (const E_TransferSyntax oxfer) const
| return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax.
const char * | getTagName ()
| return the DICOM attribute tag name for this object.
void | setTagVR (DcmEVR vr)
| set the VR for this attribute
E_TransferState | getTransferState () const
| return the current transfer state of this object during serialization/deserialization
void | setTransferState (E_TransferState newState)
| set the current transfer state of this object during serialization/deserialization
Uint32 | getTransferredBytes () const
| return the number of transferred bytes for this object during serialization/deserialization
void | setTransferredBytes (Uint32 val)
| set the number of transferred bytes for this object during serialization/deserialization
void | incTransferredBytes (Uint32 val)
| add to the number of transferred bytes for this object during serialization/deserialization
void | setLengthField (Uint32 val)
| set the current value of the Length field
Static Protected Member Functions inherited from DcmByteString
static OFBool | containsExtendedCharacters (const char *stringVal, const size_t stringLen)
| check if a given character string contains non-ASCII characters.
static OFCondition | checkStringValue (const OFString &value, const OFString &vm, const OFString &vr, const int vrID, const size_t maxLen=0, const OFString &charset="")
| check whether given string value conforms to a certain VR and VM.
Static Protected Member Functions inherited from DcmObject
static OFCondition | writeTag (DcmOutputStream &outStream, const DcmTag &tag, const E_TransferSyntax oxfer)
| static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax.
Protected Attributes inherited from DcmObject
OFCondition | errorFlag
| error flag for this object.

## Detailed Description

a class representing the DICOM value representation 'Date' (DA)

## Constructor & Destructor Documentation

## DcmDate() [1/2]

DcmDate::DcmDate | ( | const DcmTag & | tag,
|  | const Uint32 | len = 0 )

constructor.

Create new element from given tag and length.

Parameters

  tag | DICOM tag for the new element
  len | value length for the new element

Referenced by DcmDate(), clone(), and operator=().

## DcmDate() [2/2]

DcmDate::DcmDate | ( | const DcmDate & | old | ) |

copy constructor

Parameters

  old | element to be copied

References DcmDate().

## Member Function Documentation

## check() [1/2]

OFBool DcmDate::check | ( | const char * | dicomDate,
|  | const size_t | dicomDateSize )

static

check whether the given string conforms to a single value of VR "DA" (Date).

The old (prior V3.0) date format is considered invalid.

Parameters

  dicomDate | string value to be checked. An empty string is not regarded as valid input, since the date would be unknown
  dicomDateSize | the size (in bytes) of the string 'dicomDate' refers to

Returns
  OFTrue if the given string conforms to the Date format, OFFalse otherwise

## check() [2/2]

OFBool DcmDate::check | ( | const char * | dicomDate,
|  | const size_t | dicomDateSize,
|  | const OFBool | supportOldFormat )

static

check whether the given string conforms to a single value of VR "DA" (Date).

Parameters

  dicomDate | string value to be checked. An empty string is not regarded as valid input, since the date would be unknown
  dicomDateSize | the size (in bytes) of the string 'dicomDate' refers to
  supportOldFormat | whether to accept the old (prior V3.0) date format. Set to OFTrue for enabling support for "YYYY.MM.DD" in addition to "YYYYMMDD".

Returns
  OFTrue if the given string conforms to the Date format, OFFalse otherwise

## checkStringValue()

OFCondition DcmDate::checkStringValue | ( | const OFString & | value,
|  | const OFString & | vm = "1-n",
|  | const OFBool | oldFormat = OFFalse )

static

check whether given string value conforms to the VR "DA" (Date) and to the specified VM.

Parameters

  value | string value to be checked (possibly multi-valued)
  vm | value multiplicity (according to the data dictionary) to be checked for. (See DcmElement::checkVM() for a list of valid values.)
  oldFormat | support old ACR/NEMA date format if OFTrue (i.e. with "." delimiters)

Returns
  status of the check, EC_Normal if value is correct, an error code otherwise

## checkValue()

virtual OFCondition DcmDate::checkValue | ( | const OFString & | vm = "1-n",
|  | const OFBool | oldFormat = OFFalse )

virtual

check whether stored value conforms to the VR and to the specified VM

Parameters

  vm | value multiplicity (according to the data dictionary) to be checked for. (See DcmElement::checkVM() for a list of valid values.)
  oldFormat | support old ACR/NEMA format if OFTrue ('.' as a separator)

Returns
  status of the check, EC_Normal if value is correct, an error code otherwise

Reimplemented from DcmElement.

## clone()

virtual DcmObject * DcmDate::clone | ( |  | ) | const

inline virtual

clone method

Returns
  deep copy of this object

Reimplemented from DcmByteString.

References DcmDate(), and DcmObject::DcmObject().

## combinationMatches()

virtual OFBool DcmDate::combinationMatches | ( | const DcmElement & | keySecond,
|  | const DcmElement & | candidateFirst,
|  | const DcmElement & | candidateSecond ) const

virtual

perform combined attribute matching.

Combine the given Attributes to one pair of matching key and candidate respectively and perform attribute matching on the result.

Note
  The DICOM standard currently defines combined attribute matching for the VR DA in combination with TM, such that two attributes can be combined into a single attribute with VR=DT before matching against another pair of attributes with VR DA and TM. The method will return OFFalse if this element's VR is not DA or the given attributes are not of VR TM, DA and TM respectively.

Parameters

  keySecond | the second part of the matching key that will be combined with this element.
  candidateFirst | the first part of the candidate that will be matched against this this element + keySecond.
  candidateSecond | the second part of the candidate that will be combined with candidateFirst for matching against this element + keySecond.

Returns
  OFTrue if the combination of this element and keySecond match with the combination of candidateFirst and candidateSecond. OFFalse otherwise.

Reimplemented from DcmElement.

References DcmElement::DcmElement().

## copyFrom()

virtual OFCondition DcmDate::copyFrom | ( | const DcmObject & | rhs | ) |

virtual

Virtual object copying.

This method can be used for DcmObject and derived classes to get a deep copy of an object. Internally the assignment operator is called if the given DcmObject parameter is of the same type as "this" object instance. If not, an error is returned. This function permits copying an object by value in a virtual way which therefore is different to just calling the assignment operator of DcmElement which could result in slicing the object.

Parameters

  rhs | - [in] The instance to copy from. Has to be of the same class type as "this" object

Returns
  EC_Normal if copying was successful, error otherwise

Reimplemented from DcmByteString.

References DcmObject::DcmObject().

## getCurrentDate()

OFCondition DcmDate::getCurrentDate | ( | OFString & | dicomDate | ) |

static

get the current system date.

The DICOM DA format supported by this function is "YYYYMMDD". If the current system date is unavailable the date is set to "19000101" and an error code is returned.

Parameters

  dicomDate | reference to string variable where the result is stored

Returns
  EC_Normal upon success, an error code otherwise

## getDicomDateFromOFDate()

OFCondition DcmDate::getDicomDateFromOFDate | ( | const OFDate & | dateValue,
|  | OFString & | dicomDate )

static

get the specified OFDate value in DICOM format.

The DICOM DA format supported by this function is "YYYYMMDD". If the specified date is invalid the date is set to "19000101" and an error code is returned.

Parameters

  dateValue | date to be converted to DICOM format
  dicomDate | reference to string variable where the result is stored

Returns
  EC_Normal upon success, an error code otherwise

## getISOFormattedDate()

OFCondition DcmDate::getISOFormattedDate | ( | OFString & | formattedDate,
|  | const unsigned long | pos = 0,
|  | const OFBool | supportOldFormat = OFTrue )

get the current element value in ISO date format.

The ISO date format supported by this function is "YYYY-MM-DD". Please note that the element value is expected to be in valid DICOM DA format ("YYYYMMDD", "YYYY.MM.DD" is also supported for reasons of backward compatibility). If this function fails or the current element value is empty, the result variable 'formattedDate' is cleared automatically.

Parameters

  formattedDate | reference to string variable where the result is stored
  pos | index of the element component in case of value multiplicity (0..vm-1)
  supportOldFormat | if OFTrue support old (prior V3.0) date format (see above)

Returns
  EC_Normal upon success, an error code otherwise

References DcmByteString::matches().

## getISOFormattedDateFromString()

OFCondition DcmDate::getISOFormattedDateFromString | ( | const OFString & | dicomDate,
|  | OFString & | formattedDate,
|  | const OFBool | supportOldFormat = OFTrue )

static

get the specified DICOM date value in ISO format.

The ISO date format supported by this function is "YYYY-MM-DD". Please note that the specified value is expected to be in valid DICOM DA format ("YYYYMMDD", "YYYY.MM.DD" is also supported for reasons of backward compatibility). If this function fails or the specified DICOM date value is empty, the result variable 'formattedDate' is cleared automatically.

Parameters

  dicomDate | string value in DICOM DA format to be converted to ISO format
  formattedDate | reference to string variable where the result is stored
  supportOldFormat | if OFTrue support old (prior V3.0) date format (see above)

Returns
  EC_Normal upon success, an error code otherwise

## getOFDate()

OFCondition DcmDate::getOFDate | ( | OFDate & | dateValue,
|  | const unsigned long | pos = 0,
|  | const OFBool | supportOldFormat = OFTrue )

get the current element value in OFDate format.

Please note that the element value is expected to be in valid DICOM DA format ("YYYYMMDD", "YYYY.MM.DD" is also supported for reasons of backward compatibility). If this function fails the result variable 'dateValue' is cleared automatically.

Parameters

  dateValue | reference to OFDate variable where the result is stored
  pos | index of the element component in case of value multiplicity (0..vm-1)
  supportOldFormat | if OFTrue support old (prior V3.0) date format (see above)

Returns
  EC_Normal upon success, an error code otherwise

## getOFDateFromString() [1/4]

OFCondition DcmDate::getOFDateFromString | ( | const char * | dicomDate,
|  | const size_t | dicomDateSize,
|  | OFDate & | dateValue )

static

get the specified DICOM date value in OFDate format.

Please note that the specified value is expected to be in valid DICOM DA format ("YYYYMMDD", "YYYY.MM.DD" is also supported for reasons of backward compatibility). If this function fails, the result variable 'dateValue' is cleared automatically.

Parameters

  dicomDate | string value in DICOM DA format to be converted to OFDate format. An empty string is not regarded as valid input, since the date would be unknown.
  dicomDateSize | the size (in bytes) of the string 'dicomDate' refers to
  dateValue | reference to OFDate variable where the result is stored

Returns
  EC_Normal upon success, an error code otherwise

## getOFDateFromString() [2/4]

OFCondition DcmDate::getOFDateFromString | ( | const char * | dicomDate,
|  | const size_t | dicomDateSize,
|  | OFDate & | dateValue,
|  | const OFBool | supportOldFormat )

static

get the specified DICOM date value in OFDate format.

Please note that the specified value is expected to be in valid DICOM DA format ("YYYYMMDD", "YYYY.MM.DD" is also supported for reasons of backward compatibility). If this function fails, the result variable 'dateValue' is cleared automatically.

Parameters

  dicomDate | string value in DICOM DA format to be converted to OFDate format. An empty string is not regarded as valid input, since the date would be unknown.
  dicomDateSize | the size (in bytes) of the string 'dicomDate' refers to
  dateValue | reference to OFDate variable where the result is stored
  supportOldFormat | set to OFFalse to disable support for old (prior V3.0) date format (see above).

Returns
  EC_Normal upon success, an error code otherwise

## getOFDateFromString() [3/4]

OFCondition DcmDate::getOFDateFromString | ( | const OFString & | dicomDate,
|  | OFDate & | dateValue )

static

get the specified DICOM date value in OFDate format.

Please note that the specified value is expected to be in valid DICOM DA format ("YYYYMMDD", "YYYY.MM.DD" is also supported for reasons of backward compatibility). If this function fails, the result variable 'dateValue' is cleared automatically.

Parameters

  dicomDate | string value in DICOM DA format to be converted to OFDate format. An empty string is not regarded as valid input, since the date would be unknown.
  dateValue | reference to OFDate variable where the result is stored

Returns
  EC_Normal upon success, an error code otherwise

## getOFDateFromString() [4/4]

OFCondition DcmDate::getOFDateFromString | ( | const OFString & | dicomDate,
|  | OFDate & | dateValue,
|  | const OFBool | supportOldFormat )

static

get the specified DICOM date value in OFDate format.

Please note that the specified value is expected to be in valid DICOM DA format ("YYYYMMDD", "YYYY.MM.DD" is also supported for reasons of backward compatibility). If this function fails, the result variable 'dateValue' is cleared automatically.

Parameters

  dicomDate | string value in DICOM DA format to be converted to OFDate format. An empty string is not regarded as valid input, since the date would be unknown.
  dateValue | reference to OFDate variable where the result is stored
  supportOldFormat | set to OFFalse to disable support for old (prior V3.0) date format (see above).

Returns
  EC_Normal upon success, an error code otherwise

## getOFString()

virtual OFCondition DcmDate::getOFString | ( | OFString & | stringVal,
|  | const unsigned long | pos,
|  | OFBool | normalize = OFTrue )

virtual

get a copy of a particular string component

Parameters

  stringVal | variable in which the result value is stored
  pos | index of the value in case of multi-valued elements (0..vm-1)
  normalize | delete trailing spaces if OFTrue

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmByteString.

## ident()

virtual DcmEVR DcmDate::ident | ( |  | ) | const

virtual

get element type identifier

Returns
  type identifier of this class (EVR_DA)

Reimplemented from DcmByteString.

## matches() [1/2]

virtual OFBool DcmByteString::matches | ( | const DcmElement & | candidate,
|  | const OFBool | enableWildCardMatching = OFTrue ) const

virtual

perform attribute matching.

Perform attribute matching on a candidate element using this element as the matching key.

Note
  The given candidate element must refer to the same attribute kind, i.e. have the same tag and VR. The method will return OFFalse if it doesn't.

Parameters

  candidate | the candidate element to compare this element with.
  enableWildCardMatching | enable or disable wild card matching. Defaults to OFTrue, which means wild card matching is performed if the element's VR supports it. Set to OFFalse to force single value matching instead.

Returns
  OFTrue if the candidate matches this element, OFFalse otherwise.

Reimplemented from DcmByteString.

## matches() [2/2]

virtual OFBool DcmDate::matches | ( | const OFString & | key,
|  | const OFString & | candidate,
|  | const OFBool | enableWildCardMatching = OFTrue ) const

virtual

perform attribute matching on a single pair of string values.

Compare two single string values using the attribute matching function appropriate for this element's VR (Universal Matching, Single Value Matching, Wild Card Matching or Range Matching).

Note
  This method is called by the other overload of matches() for each combination of values in the key and candidate element (implementing multi value matching for elements with VM>1).

Parameters

  key | the key value to match against the candidate.
  candidate | the candidate value to match the key against.
  enableWildCardMatching | enable or disable wild card matching. Defaults to OFTrue, which means wild card matching is performed if the element's VR supports it. Set to OFFalse to force single value matching instead.

Returns
  OFTrue if the candidate string matches the key string, OFFalse otherwise.

Reimplemented from DcmByteString.

## operator=()

DcmDate & DcmDate::operator= | ( | const DcmDate & | obj | ) |

assignment operator

Parameters

  obj | element to be assigned/copied

Returns
  reference to this object

References DcmDate().

## setCurrentDate()

OFCondition DcmDate::setCurrentDate | ( |  | ) |

set the element value to the current system date.

The DICOM DA format supported by this function is "YYYYMMDD". If the current system date is unavailable the date is set to "19000101" and an error code is returned.

Returns
  EC_Normal upon success, an error code otherwise

## setOFDate()

OFCondition DcmDate::setOFDate | ( | const OFDate & | dateValue | ) |

set the element value to the given date

Parameters

  dateValue | date to be set (should be a valid date)

Returns
  EC_Normal upon success, an error code otherwise

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcvrda.h

Generated on for DCMTK Version 3.7.0 by Doxygen 1.15.0